commit 833b180f097e8bae44634e6a31e9c92d661af301
Author: Patrick Palka <ppalka@redhat.com>
Date:   Wed Oct 28 11:47:26 2020 -0400

    c++: Check constraints before instantiation from mark_used [PR95132]
    
    This makes mark_used check constraints of a function _before_ calling
    maybe_instantiate_decl, so that we don't try instantiating a function
    (as part of return type deduction) with unsatisfied constraints.
    
    gcc/cp/ChangeLog:
    
            PR c++/95132
            * decl2.c (mark_used): Move up the constraints_satisfied_p check
            so that we check constraints before calling maybe_instantiate_decl.
    
    gcc/testsuite/ChangeLog:
    
            PR c++/95132
            * g++.dg/cpp2a/concepts-fn7.C: New test.
    
    (cherry picked from commit 9ccc3495766116ea4ae8e4cd8129beca60e30445)

diff --git a/gcc/testsuite/g++.dg/cpp2a/concepts-fn7.C b/gcc/testsuite/g++.dg/cpp2a/concepts-fn7.C
new file mode 100644
index 00000000000..62111df310e
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/concepts-fn7.C
@@ -0,0 +1,11 @@
+// PR c++/95132
+// { dg-do compile { target c++20 } }
+
+template <class T> struct A {
+  static auto f() requires false { return T::fail; }
+};
+
+template <class T>
+concept C = requires { A<T>::f(); };
+
+static_assert(!C<int>);

